// M浏览器交互脚本

// -- 审查元素
var nElementDebugState = false; // 启用元素调试模式

function mbrowserElementDebugStart(state) {
    nElementDebugState = state;
    if (state === false) {
        if (cutSelectObj !== undefined && cutObjHtml != null){
            // 如果改成了 display:none!important 则不管他 否则恢复原样
            if(cutSelectObj.getAttribute("style") != "display:none!important"){
                if(curElementStyle === null) cutSelectObj.removeAttribute("style");
                else cutSelectObj.setAttribute("style",curElementStyle);
            }
           
        }
    }
}

var cutSelectObj; // 当前选中对象
var cutObjHtml; // 当前对象源码
var cutSelectParent; // 当前选中的父对象
var curElementStyle; // 选中元素默认的style值

window.onclick = function(ev) {
    if (nElementDebugState === true){
        var e1 = ev || event; // 选中当前项
            var obj = e1.srcElement ? e1.srcElement: e1.target;
            obj = obj ? obj : ev;
            mbrowser_element_select(obj);
    }

};

function testss(ev){
    // alert(ev.innerHTML);
    alert('test' + ev)
}

function mbrowser_element_select(ev) {
    if (cutSelectObj !== undefined && cutObjHtml != null){
        if(curElementStyle === null) cutSelectObj.removeAttribute("style");
        else cutSelectObj.setAttribute("style",curElementStyle);
    }
    if(ev == null) return;

    cutSelectObj = ev;
    cutSelectParent = cutSelectObj.parentNode;

    cutSelectObj2 = cutSelectObj;
    cutSelectParent2 = cutSelectParent;

    cutObjHtml = cutSelectObj.outerHTML;
    curElementStyle = cutSelectObj.getAttribute("style");

    cutSelectObj.style.backgroundColor = "#87CEFA";
    cutSelectObj.style.borderStyle = "solid";
    cutSelectObj.style.borderColor = "#6A5ACD";
    cutSelectObj.style.borderWidth = "2px";
    win_echo_element_select_info();
}

function mbrowser_element_getPatent() {
    mbrowser_element_select(cutSelectParent);
}

function mbrowser_element_editHtml(v) {
    if(cutSelectObj === null) return;
    cutSelectObj.outerHTML = v;
    window.webmx.mbrowser_element_select_value_callback(0,"");
    window.webmx.mbrowser_element_select_value_callback(1,"");
    window.webmx.mbrowser_element_select_value_callback(2,"");
    window.webmx.mbrowser_element_select_value_callback(3,"");

}

// -- 审查元素，只取内容，不做界面处理
var cutSelectObj2; // 隐藏的选中项
var cutSelectParent2; // 隐藏选中的父对象
function mbrowser_element_getPatent2() {
    cutSelectObj2 = cutSelectParent2;
    cutSelectParent2 = cutSelectObj2.parentNode;
    win_echo();
}

function win_echo_element_select_info() {
    window.webmx.mbrowser_element_select_value_callback(0,cutObjHtml);
    window.webmx.mbrowser_element_select_value_callback(1,cutSelectParent.outerHTML);
    window.webmx.mbrowser_element_select_value_callback(2,cutSelectObj2.outerHTML);
    window.webmx.mbrowser_element_select_value_callback(3,cutSelectParent2.outerHTML);
}

function debug_inin(){
    window.webmx.readyState('scriptEnd');
    m_iframe();
}
debug_inin();

function m_iframe(){
    var arr = document.getElementsByTagName('iframe');
    var size = 0
    for(var i = 0; i < arr.length; i++){
        var tag = arr[i];
        if(tag.offsetWidth > 10) {
            size = tag.offsetWidth;
            break;
        }
    }
    window.webmx.iframex(size)
}


/* tm */
var tmapi_value = {};
function GM_addResource(a,v) {
    tmapi_value[a] = v;
}
function GM_deleteValue(a){
    tmapi_value.remove(a);
}

function GM_log(a){
    window.webmx.tmapi_log(a);
}

function GM_setValue(a,v){
    GM_addResource(a,v);
}

function GM_getValue(a) {
    return tmapi_value[a];

}
function GM_getResourceText(a) {
    return tmapi_value[a];

}
function GM_getResourceURL(a) {
    return tmapi_value[a];
}

function GM_xmlhttpRequest(a) {
    if(!a.url){
        a.onerror();
        return;
    }

    var url = a.url;
    var timeout = 0;
    if(!(!a.timeout)) timeout = a.timeout;

    var method = "GET";
    if(!(!a.method)) method = a.method;

    var data = "";
    if(!(!a.data)) data = JSON.stringify(a.data);

    var headers = "";
    if(!(!a.headers)) headers = JSON.stringify(a.headers);

    var responseType;
    if(!(!a.responseType)) responseType =  a.responseType;

    var code = "";
    code = window.webmx.xmlhttprequest(timeout,method,url,data,headers,responseType);

    if(code === "ontimeout"){
        a.ontimeout();
    }else if(code === "404"){
        a.onerror();
    }else{
        var pr = JSON.parse(code);
        pr.responseText = pr.response;
        a.onload(pr);
    }
}

function GM_addStyle(css){
    var head, style;
    head = document.getElementsByTagName('head')[0];
    if (!head) { return; }
    style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = css;
    head.appendChild(style);
}

function GM_openInTab(url) {
    GM_openInTab(url,true);
}

function GM_openInTab(url,jump) {
    window.webmx.openUrl(url);
}

function GM_setClipboard(b) {
    var a = b.content,
        d = b.info,
        e = typeof d,
        l, f;
    "object" === e ? (d.type && (l = d.type), d.mimetype && (f = d.mimetype)) : "string" === e && (l = d);
    var g = function(b) {
        document.removeEventListener("copy", g, !0);
        b.stopImmediatePropagation();
        b.preventDefault();
        b.clipboardData.setData(f || ("html" === l ? "text/html": "text/plain"), a)
    };
    document.addEventListener("copy", g, !0);
    document.execCommand("copy");
}






